@echo off
set version=NWIDG v3.10
REM ************************************************************************
REM
REM   INSTALLAZIONE AUTOMATICA DEL NOS NWIDG DAI FILE ARJ DI DISTRIBUZIONE
REM                              Versione 0.5
REM                                    
REM                                 /// \\\
REM                                !! O^O !!
REM                   ---------oOO----(_)----OOo----------   
REM                   I1EPJ HOC FECIT ANNO DOMINI MCMXCVII
REM                   ------------------------------------
REM
REM ************************************************************************
REM
REM Schermata di presentazione
REM
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ
echo                                                                             
echo   Questa programma costruir la struttura delle directory richiesta (se gi 
echo   non esistente) e vi copier i vari file estraendoli dagli archivi .ARJ di 
echo   distribuzione. Una installazione completa richiede circa 1.3 Mb.          
echo                                                                             
echo   I seguenti file sono RICHIESTI e vanno posti nella stessa directory o     
echo   disco che contiene questo programma (INSTALL.BAT o INSTALL.COM):          
echo                                                                             
echo   NOSxxxyy.ARJ        CNFFILES.ARJ        NWIDGDOC.ARJ        HLPFILES.ARJ  
echo                                                                             
echo   Se presenti, verranno altres scompattati e posti nelle opportune         
echo   directory i file contenuti nei seguenti archivi:                          
echo                                                                             
echo   AREAMAN.ARJ         MAKEFING.ARJ        PCELMxxx.ARJ        MSGKIT.ARJ    
echo   GPCMESCC.ARJ        GPCMTEST.ARJ        SETUSER.ARJ         FTPMX.ARJ     
echo                                                                             
echo   Occorre inoltre disporre del programma ARJ.EXE o nella stessa directory   
echo   che contiene questi file oppure in una directory compresa nel PATH.       
echo                                                                             
echo   Questo programma  previsto per funzionare sotto MS-DOS 5.0, 6.0 e 6.2;   
echo   il funzionamento sotto altre versioni di DOS pu risultare non corretto.  
echo 
pause

REM
REM Verifica la presenza del parametro (HD dove installare)
REM
if "%1" == "" goto nodrive                                                     

REM
REM Verifica la presenza di ARJ.EXE
REM
arj zzz > nul
if errorlevel 1 goto arj_found
goto noarj

REM
REM Verifica la presenza dei file ARJ di installazione
REM
:arj_found
if not exist .\nos*.arj goto noexe
if not exist .\cnffiles.arj goto nocnf
if not exist .\hlpfiles.arj goto nohlp
if not exist .\nwidgdoc.arj goto nodoc

REM
REM Verifica se la directory NOS esiste, se no occorre farle tutte
REM
if not exist %1\nos\nul goto makedir

REM
REM Verifica se sotto la directory NOS esistono tutte le subdir richieste
REM
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ 
echo                                                                             
echo Ĵ
echo           Sto verificando la struttura delle directory sul drive %1         
echo 
if not exist %1\nos\bin\nul md %1\nos\bin
if not exist %1\nos\doc\nul md %1\nos\doc
if not exist %1\nos\etc\nul md %1\nos\etc
if not exist %1\nos\finger\nul md %1\nos\finger
if not exist %1\nos\spool\nul md %1\nos\spool
if not exist %1\nos\spool\help\nul md %1\nos\spool\help
if not exist %1\nos\spool\mail\nul md %1\nos\spool\mail
if not exist %1\nos\spool\mqueue\nul md %1\nos\spool\mqueue
if not exist %1\nos\spool\rqueue\nul md %1\nos\spool\rqueue
if not exist %1\nos\spool\mbox\nul md %1\nos\spool\mbox
if not exist %1\nos\spool\logs\nul md %1\nos\spool\logs
if not exist %1\nos\spool\news\nul md %1\nos\spool\news
if not exist %1\nos\spool\signatur\nul md %1\nos\spool\signatur
if not exist %1\nos\src\nul md %1\nos\src
if not exist %1\nos\usr\nul md %1\nos\usr
if not exist %1\nos\usr\public\nul md %1\nos\usr\public
goto unarj

REM
REM Costruisce la struttura delle directory
REM
:makedir
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ 
echo                                                                             
echo Ĵ
echo                   Sto costruendo le directory sul drive %1                  
echo 
md %1\nos
md %1\nos\bin
md %1\nos\doc
md %1\nos\etc
md %1\nos\finger
md %1\nos\spool
md %1\nos\spool\help
md %1\nos\spool\mail
md %1\nos\spool\mqueue
md %1\nos\spool\rqueue
md %1\nos\spool\mbox
md %1\nos\spool\logs
md %1\nos\spool\news
md %1\nos\spool\signatur
md %1\nos\src
md %1\nos\usr
md %1\nos\usr\public

REM
REM Scompatta i file necessari
REM
:unarj
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ 
echo                                                                             
echo Ĵ
echo                    Sto scompattando gli archivi richiesti                   
echo Ĵ
echo                               NOSxxxyy.ARJ                                  
echo Ĵ
arj e -y nos*.arj %1\nos\bin > nul
echo                               CNFFILES.ARJ                                  
echo Ĵ
arj e -y cnffiles.arj %1\nos\etc > nul
echo                               HLPFILES.ARJ                                  
echo Ĵ
arj e -y hlpfiles.arj %1\nos\spool\help > nul
echo                               NWIDGDOC.ARJ                                  
echo 
arj e -y nwidgdoc.arj %1\nos\doc > nul

REM
REM Cerca e scompatta i file accessori
REM
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ 
echo                                                                             
echo Ĵ
echo              Sto cercando e scompattando gli archivi accessori              
echo Ĵ

if not exist .\pcelm*.arj goto next1
echo                               PCELMxx.ARJ                                   
echo Ĵ
arj e -y pcelm* %1\nos\bin > nul
copy %1\nos\bin\pcelm.rc %1\nos\etc > nul
del %1\nos\bin\pcelm.rc > nul

:next1
if not exist .\areaman.arj goto next2
echo                               AREAMAN.ARJ                                   
echo Ĵ
arj e -y areaman.arj %1\nos\bin > nul
copy %1\nos\bin\areaman.cnf %1\nos\etc > nul
del %1\nos\bin\areaman.cnf > nul

:next2
if not exist .\ftpmx.arj goto next3
echo                                FTPMX.ARJ                                    
echo Ĵ
arj e -y ftpmx.arj %1\nos\bin > nul

:next3
if not exist .\msgkit.arj goto next4
echo                                MSGKIT.ARJ                                   
echo Ĵ
arj e -y msgkit.arj %1\nos\bin > nul
copy %1\nos\bin\nosmsg.src %1\nos\src > nul
del %1\nos\bin\nosmsg.src > nul

:next4
if not exist .\makefing.arj goto next5
echo                               MAKEFING.ARJ                                  
echo Ĵ
arj e -y makefing.arj %1\nos\bin > nul

:next5
if not exist .\setuser.arj goto next6
echo                                SETUSER.ARJ                                  
echo Ĵ

arj e -y setuser.arj %1\nos\bin > nul
copy %1\nos\bin\setuser.cfg %1\nos\etc > nul
del  %1\nos\bin\setuser.cfg > nul

:next6
if not exist .\gpcmescc.arj goto next7
echo                                GPCMESCC.ARJ                                 
echo Ĵ
arj e -y gpcmescc.arj %1\nos\src > nul

:next7
if not exist .\gpcmtest.arj goto next8
echo                                GPCMTEST.ARJ                                 
echo Ĵ
arj e -y gpcmtest.arj %1\nos\bin > nul
copy %1\nos\bin\*.c %1\nos\src > nul
copy %1\nos\bin\*.h %1\nos\src > nul
copy %1\nos\bin\copying %1\nos\src > nul
del %1\nos\bin\*.c
del %1\nos\bin\*.h
del %1\nos\bin\copying

goto continue

:next8
echo                                                                             
echo 

:continue
%1
cd %1\nos\bin
if exist *.c copy *.c %1\nos\src > nul
if exist *.h copy *.h %1\nos\src > nul

if exist *.doc copy *.doc %1\nos\doc > nul
if exist *.c del *.c > nul
if exist *.h del *.h > nul
if exist *.doc del *.doc > nul
%1
cd %1\nos\etc
if exist nos_rem.bat copy nos_rem.bat %1\nos > nul
del nos_rem.bat > nul

goto end0

REM
REM  Gestione errori 
REM
:nodrive
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ
echo                                                                             
echo Ĵ
echo                                   ERRORE                                    
echo Ĵ
echo     Occorre specificare il drive su cui installare il NOS; ad esempio, per  
echo     installare il NOS %version% sul disco C: dare il comando:              
echo                                                                             
echo     INSTALL C:                                                              
echo 
goto end2

:noexe
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ
echo                                                                             
echo Ĵ
echo                                   ERRORE                                    
echo Ĵ
echo         Non trovo nessun file NOSxxxyy.ARJ nella directory corrente.        
echo 
goto end2

:nocnf
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ
echo                                                                             
echo Ĵ
echo                                    ERRORE                                   
echo Ĵ
echo         Non trovo il file CNFFILES.ARJ nella directory corrente.            
echo 
goto end2

:nohlp
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ
echo                                                                             
echo Ĵ
echo                                    ERRORE                                   
echo Ĵ
echo          Non trovo il file HLPFILES.ARJ nella directory corrente.           
     
goto end2

:nodoc
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ
echo                                                                             
echo Ĵ
echo                                    ERRORE                                   
echo Ĵ
echo          Non trovo il file NWIDGDOC.ARJ nella directory corrente.           
echo 
goto end2

:noarj
cls
echo ĴINSTALLAZIONE AUTOMATICA DEL NOS %version%Ŀ
echo                                                                             
echo Ĵ
echo                                    ERRORE                                   
echo Ĵ
echo    Non trovo il programma ARJ.EXE n nella directory corrente n nel PATH.  
echo 
goto end2


REM
REM Passa nella directory /nos/usr/public e ci scrive un file
REM
:end0
cd %1\nos\usr\public
echo ---------------------------------------------------------------- > readme.pub
echo In questa directory (/nos/usr/public/) vanno posti i file che si >> readme.pub
echo desidera rendere accessibili a tutti gli utenti del sistema. >> readme.pub
echo ---------------------------------------------------------------- >> readme.pub

REM
REM Passa nella directory /nos
REM
cls
%1
cd %1\nos

REM
REM Costruisce i file .BAT di lancio del NOS
REM
if not exist %1\nos\bin\nos386.exe goto no386
echo @echo off > n386.bat
echo if "%%nosbinadded%%" == "y" goto nopath >> n386.bat
echo path=%1\nos\bin;%%path%% >> n386.bat
echo set nosbinadded=y>> n386.bat
echo :nopath >> n386.bat
echo set mailer=%1\nos\bin\pcelm386 >> n386.bat
echo %1\nos\bin\nos386 %%1 %%2 -d %1\nos >> n386.bat

:no386
if not exist %1\nos\bin\nos286.exe goto no286
echo @echo off > n286.bat
echo if "%%nosbinadded%%" == "y" goto nopath >> n286.bat
echo path=%1\nos\bin;%%path%% >> n286.bat
echo set nosbinadded=y>> n286.bat
echo :nopath >> n286.bat
echo set mailer=%1\nos\bin\pcelm286 >> n286.bat
echo %1\nos\bin\nos286 %%1 %%2 -d %1\nos >> n286.bat

:no286
if not exist %1\nos\bin\nos186.exe goto no186
echo @echo off > n186.bat
echo if "%%nosbinadded%%" == "y" goto nopath >> n186.bat
echo path=%1\nos\bin;%%path%% >> n186.bat
echo set nosbinadded=y>> n186.bat
echo :nopath >> n186.bat
echo set mailer=%1\nos\bin\pcelm86 >> n186.bat
echo %1\nos\bin\nos186 %%1 %%2 -d %1\nos >> n186.bat

:no186
if not exist %1\nos\bin\nos86.exe goto end1
echo @echo off > n86.bat
echo if "%%nosbinadded%%" == "y" goto nopath >> n86.bat
echo path=%1\nos\bin;%%path%% >> n86.bat
echo set nosbinadded=y>> n86.bat
echo :nopath >> n86.bat
echo set mailer=%1\nos\bin\pcelm86 >> n86.bat
echo %1\nos\bin\nos86 %%1 %%2 -d %1\nos >> n86.bat

REM
REM Costruisce i file .BAT di lancio del programma di test
REM
echo @echo off > test.bat
echo bin\gpcmtest %%1 >> test.bat

REM
REM Se  disponibile il programma MAKEFING lo lancia
REM 

if exist %1\nos\bin\makefing.exe %1\nos\bin\makefing > nul

REM
REM Messaggio di fine installazione
REM
:end1
cls
echo ͻ
echo                          INSTALLAZIONE COMPLETATA                           
echo ͹
echo                               ATTENZIONE !!!!                               
echo ͹
echo   Prima di lanciare il NOS ricordarsi di editare i file di configurazione   
echo   presenti in %1\NOS\ETC ed il file %1\NOS\SPOOL\HELP\INFO.TXT, che DEVONO  
echo   essere personalizzati coi VOSTRI dati (nominativo, IP address, porte se-  
echo   riali usate) e non lasciati coi dati attuali che sono SOLO di esempio !!  
echo                                                                             
echo   Per eseguire la personalizzazione  sufficiente un qualsiasi text editor  
echo   (ad esempio EDIT del DOS), in quanto tutti i file di configurazione sono  
echo   dei semplici file di testo.                                               
echo                                                                             
echo   Si raccomanda inoltre di leggere attentamente i file di documentazione    
echo   che sono stati memorizzati in %1\NOS\DOC.                                 
echo                                                                             
echo   Per lanciare il NOS utilizzare i file .BAT previsti (Nxxx.BAT).           
echo ͼ
echo ͻ
echo  Buon TCP/IP col NOS NWIDG dal Gruppo Packet della Sezione ARI di Casale !! 
echo ͼ

REM
REM Fine programma
REM
:end2
set version=
